/* Version 1.1 (Beta Test)
 * Copyright (c) Rui Zhang, 2005-2006
 *
 * Permission is hereby given for the use of the code subject to the
 *  following conditions:
 *  - The code will not be sold for profit without explicit written
 *    permission from Rui Zhang.
 *  - This copyright notice and author information will not be altered
 *  - All bug fixes will be returned to the rui@csse.unimelb.edu.au for
 *    inclusion in future releases
 */

#ifndef __BT_DELETE_H
#define __BT_DELETE_H

typedef enum {
  NO_OP,
  REDIST_LEFT, REDIST_RIGHT,
  MERGE_LEFT, MERGE_RIGHT
} DEL_RESULT;

int BT_Delete(BTREE *, RECORD_TYPE *, const KEYTYPE); 
DEL_RESULT BT_DeleteR(BTREE *, PTR, PTR, PTR, KEYTYPE *, KEYTYPE *, RECORD_TYPE *, const KEYTYPE);
DEL_RESULT BT_Redistribute_INode(BTREE *, INODE *, INODE *, INODE *, PTR ,PTR, PTR, KEYTYPE *, KEYTYPE *);
int BT_Merge_INode(BTREE *, INODE *, INODE *, PTR, PTR, KEYTYPE);
DEL_RESULT BT_DeleteLeaf(BTREE *, PTR, PTR, PTR, KEYTYPE *, RECORD_TYPE *, const KEYTYPE);
DEL_RESULT BT_RedistAndMergeLeaf(BTREE *, LNODE *currNode, PTR , PTR, KEYTYPE *);
KEYTYPE BT_MergeLNode(BTREE *, LNODE *, LNODE *);
int BT_CheckOverflowNodes(BTREE *, LNODE *, RECORD_TYPE *, const KEYTYPE, int);
PTR BT_SelectSiblings(INODE *, KEYTYPE, PTR *, PTR *, int *);
int BT_isEqualEntry(LENTRY *, RECORD_TYPE *, const KEYTYPE);
int BT_deleteEntries(LENTRY *, int *, RECORD_TYPE *, const KEYTYPE);
void BT_Traverse(BTREE *, PTR,  int);
void error(char* errStr);


#endif
