/* Version 1.1 (Beta Test)
 * Copyright (c) Rui Zhang, 2005-2006
 *
 * Permission is hereby given for the use of the code subject to the
 *  following conditions:
 *  - The code will not be sold for profit without explicit written
 *    permission from Rui Zhang.
 *  - This copyright notice and author information will not be altered
 *  - All bug fixes will be returned to the rui@csse.unimelb.edu.au for
 *    inclusion in future releases
 */

#ifndef __CUSTOMIZE_H
#define __CUSTOMIZE_H

/************define which instance to implement*******/
//#define BTREE_
//#define IMINMAX_
//#define UBTREE_
//#define PYRAMID_
#define IDISTANCE_
/***************************************/

#ifdef BTREE_
#define NumRef 1
#endif

#ifdef IMINMAX_
#define NumRef 1
#endif

#ifdef UBTREE_
#define NumRef 1
#endif

#ifdef PYRAMID_
#define NumRef (2*D)
#endif

#ifdef IDISTANCE_
#define NumRef 64 //define it as the number of reference points used
FILE *fp_reference; //the reference points of iDistance is written in this file
DATA_TYPE RefPoint[NumRef][D];//reference points
#define CST D  //should be larger than dimensionality if use distance square;
//larger than sqrt(dimensionality) if use distance
#endif

//for key definition
RECORD_TYPE* Reference(RECORD_TYPE *pRcd, int *refnum);

KEYTYPE Distance(RECORD_TYPE*, RECORD_TYPE*);

KEYTYPE Base(RECORD_TYPE*);

//End for key definition

//for range query
IntervalListNode* MapRange(RANGE_TYPE*);
//End for range query

//for kNN query
IntervalListNode* MapAnnulus(RECORD_TYPE *q, DATA_TYPE rmin, DATA_TYPE rmax, KnnInfo *knninfo);
//End for kNN query

void Initialize( );

DATA_TYPE ActualDistance(RECORD_TYPE*,RECORD_TYPE*);

#endif
