/* Version 1.1 (Beta Test)
 * Copyright (c) Rui Zhang, 2005-2006
 *
 * Permission is hereby given for the use of the code subject to the
 *  following conditions:
 *  - The code will not be sold for profit without explicit written
 *    permission from Rui Zhang.
 *  - This copyright notice and author information will not be altered
 *  - All bug fixes will be returned to the rui@csse.unimelb.edu.au for
 *    inclusion in future releases
 */

#ifndef __SUPPORT_H
#define __SUPPORT_H

//iMinMax
int Dmax(RECORD_TYPE *pRcd);
int Dmin(RECORD_TYPE *pRcd);
//End iMinMax

//UB-tree
#define ORDER 4
typedef unsigned long Z_TYPE;
//typedef unsigned long long Z_TYPE;

typedef struct _ValueNode{
  int v;
  struct _ValueNode *next;
}ValueNode;

Z_TYPE maxz, zlimit, *bitone, *bitzero;
void Z_Initialize( );
Z_TYPE ZV(RECORD_TYPE *pRcd);
Z_TYPE ZV1(RECORD_TYPE *pRcd);
Z_TYPE getNextZvalue(Z_TYPE zv, Z_TYPE min, Z_TYPE max);
Z_TYPE getNextZvalueExit(Z_TYPE cur, Z_TYPE min, Z_TYPE max);
int IsViolation(int p, int va[], int curv, int nv);
int Bit(Z_TYPE, int);
Z_TYPE DimValue(Z_TYPE, int);
void append(ValueNode *v, int a, int *nv);
int CompareViolation( const void *arg1, const void *arg2 );
//End UB-tree

//Pyramid technique
typedef struct {
  int pyramid ;
  float height ;
} pyrval ;

KEYTYPE pv(DATA_TYPE * vector);
int intersect(RANGE_TYPE *pRg, int i, float *phlow, float *phhigh);
void DeterminRange(RANGE_TYPE *pRg, int i, float *phlow, float *phhigh);
float MIN(float f0, float f1);
float MAX(float f0, float f1);
//End Pyramid technique

#endif
